package jalview.ws.params.simple;

import jalview.ws.params.ParameterI;
import jalview.ws.params.ValueConstrainI;

/**
 * 
 * @author TZVanaalten
 *
 */
public class DoubleParameter extends Option implements ParameterI
{
  Double defval;

  Double min, max;

  @Override
  public ValueConstrainI getValidValue()
  {
    return new ValueConstrainI()
    {

      @Override
      public ValueType getType()
      {
        return ValueType.Double;
      }

      @Override
      public Number getMin()
      {
        if (min < max)
        {
          return min;
        }
        else
        {
          return null;
        }
      }

      @Override
      public Number getMax()
      {
        if (min < max)
        {
          return max;
        }
        else
        {
          return null;
        }
      }
    };
  }

  public DoubleParameter(DoubleParameter parm)
  {
    super(parm);
    max = parm.max;
    min = parm.min;
  }

  public DoubleParameter(String name, String description, boolean required,
          Double defValue, Double min, Double max)
  {
    super(name, description, required, String.valueOf(defValue), null, null,
            null);
    defval = defValue;
    this.min = min;
    this.max = max;
  }

  public DoubleParameter(String name, String description, boolean required,
          Double defValue, Double value, Double min, Double max)
  {
    super(name, description, required, String.valueOf(defValue),
            String.valueOf(value), null, null);
    defval = defValue;
    this.min = min;
    this.max = max;
  }

  @Override
  public DoubleParameter copy()
  {
    return new DoubleParameter(this);
  }
}
